"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const update = (written, completed) => {
    return (prevState, props) => {
        if (props.value) {
            return prevState;
        }
        return {
            written: written,
            completed: completed
        };
    };
};
class InputAutocomplete extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            written: (props.value && String(props.value)) || (props.defaultValue && String(props.defaultValue)) || '',
            completed: '',
        };
        this.handleOnChange = this.handleOnChange.bind(this);
    }
    fireOnChange(ev, changedValue) {
        if (!this.props.onChange) {
            return;
        }
        if (changedValue) {
            ev.currentTarget.value = changedValue;
        }
        this.props.onChange(ev);
    }
    handleOnChange(ev) {
        const target = ev.currentTarget;
        const value = target.value;
        const performMatch = value.length > this.state.written.length;
        if (!performMatch) {
            this.fireOnChange(ev);
            this.setState(update(value, ''));
            return;
        }
        const match = this.props.autocompleteValues.find(phrase => phrase.indexOf(value) == 0);
        if (match) {
            this.setState(update(value, match.replace(value, '')), () => {
                target.focus();
                target.setSelectionRange(value.length, match.length);
            });
        }
        else {
            this.setState(update(value, ''));
        }
        this.fireOnChange(ev, match);
    }
    render() {
        const _a = this.props, { autocompleteValues } = _a, props = __rest(_a, ["autocompleteValues"]);
        return React.createElement("input", Object.assign({}, props, { value: `${this.state.written}${this.state.completed}`, onChange: this.handleOnChange }));
    }
}
exports.InputAutocomplete = InputAutocomplete;
exports.default = InputAutocomplete;
//# sourceMappingURL=InputAutocomplete.js.map